#include <cstdlib>
#include <math.h>

#include "curve2.h"		//  2-   c

int curve2Coord(double a_[],double *b,double *c){ 
	// 	a_[0] + a_[1]*x + a_[2]*y + a_[3]*x*x + a_[4]*x*y + a_[5]*y*y
	double a[6] = {a_[3], a_[4], a_[5], a_[1], a_[2], a_[0]};
	double eps = 4e-14*(fabs(a[0]) + fabs(a[1]) + fabs(a[2]) + fabs(a[3]) + fabs(a[4]) + fabs(a[5])); 
/*

        a[6]      , 
	 a[0]x^2+a[1]xy+a[2]y^2+a[3]x+a[4]y+a[5]=0,
       b[6]  c[2]    . 
       :

    1.   b[6]   (b[0], b[3])
       (b[1],b[2],b[4],b[5]), , :
    x2=b[0]+b[1]x+b[2]y
    y2=b[3]+b[4]x+b[5]y

    2.   c[2]   a  b,  x^2/a^2+(-)y^2/b^2=1(0)   
	.  ,     ,
        ,      c[2]  . 

    3.  :
        0 -      
        1 -   
        2 -    
        3 -      
        4 -   
        5 -     
        6 -   
        7 -     
        8 -      
        9 -     

     ,    :
        -      ,    
		     
        -    ,    
		     

    .:       fabs(), ..   
		      

*/
    a[1]=a[1]/2;
    a[3]=a[3]/2;
    a[4]=a[4]/2;
    double I1, I2, I3,K2;
    //     :
    I1=a[0]+a[2]; // I
    I2=a[0]*a[2]-a[1]*a[1];// D
    I3=a[0]*a[2]*a[5]+2*a[3]*a[1]*a[4]-a[3]*a[3]*a[2]-a[1]*a[1]*a[5]-a[4]*a[4]*a[0]; // '' 
    K2=a[2]*a[5]-a[4]*a[4]+a[0]*a[5]-a[3]*a[3]; //
    double P=0, e=0, h=0, c1=0, s=0, t=0;
    //  ,     b[]  c[],        
    if(fabs(a[1])>eps)//  ,    xy    (x^2+2xy+y^2+2x+2y+c=0), ..    ;
    {
        if(a[0]!=0||a[2]!=0)// ,        x^2  y^2   
        {
            double q=sqrt((a[0]-a[2])*(a[0]-a[2])+4*a[1]*a[1]); 
            t=(a[2]-a[0]+q)/(2*a[1]);// tg a     ;
            /*
               b[],   :
            x1=cos a*x-sin a*y=b[1]*x+b[2]*y
            y1=sin a*x+cos a*y=b[4]*x+b[5]*y
            */
            b[1]=1/sqrt(1+t*t); //b[1]=cos a=1/sqrt(1+tg a*tg a)
            b[2]=-t/sqrt(1+t*t);//b[2]=-sin a=-tg a/sqrt(1+tg a*tg a)
            b[4]=t/sqrt(1+t*t);//b[3]=sin a=tg a/sqrt(1+tg a*tg a)
            b[5]=1/sqrt(1+t*t); //b[4]=cos a=1/sqrt(1+tg a*tg a)
            if(a[3]!=0||a[4]!=0) // ,        x  y   , ..  
            {
                s=t/sqrt(1+t*t); // sin a;
                c1=1/sqrt(1+t*t);// cos a
                e=a[0]*c1*c1+2*a[1]*c1*s+a[2]*s*s;
                //  x^2     (       )
                h=a[0]*s*s-2*a[1]*c1*s+a[2]*c1*c1;//  y^2    
                if(e==0) e=1; //     0
                if (h==0) h=1; //     0
                b[0]=(a[3]*c1+a[4]*s)/e; //   x2=x1+b[0]
                b[3]=(-a[3]*s+a[4]*c1)/h;  //   y2=y1+b[3]
                P=(a[3]*c1+a[4]*s)*(a[3]*c1+a[4]*s)/e+(a[4]*c1-a[3]*s)*(a[4]*c1-a[3]*s)/h-a[5];
                //P - ,    , .. e*x^2+h*y^2=P
                c[0]=sqrt(fabs(P/e)); //   c[],  a^2=P/e, b^2=P/h
                c[1]=sqrt(fabs(P/h)); 
            }
            else // ,    x  y  (x^2+2xy+y^2+c=0)
            {
                b[0]=b[3]=0; // ..   x  y  ,    , ,    
                e=(a[0]+2*a[1]*t+a[2]*t*t)/(1+t*t);//  x^2     (   )
                h=(a[0]*t*t-2*a[1]*t+a[2])/(1+t*t);//  y^2    
                if (e==0) e=1;//     0
                if(h==0) h=1;//     0
                if(a[5]==0){ // ,     (x^2+2xy+y^2=0)
                    c[0]=sqrt(fabs(1/e)); 
                    //  c[]: ..   e*x^2+h*y^2=0,  a^2=1/e, b^2=1/h
                    c[1]=sqrt(fabs(1/h));          
                    } 
                else
                    { // ,       (x^2+2xy+y^2+c=0)
                    c[0]=sqrt(fabs(-a[5]/e));
                    //  c[]: ..   e*x^2+h*y^2=-a[5],  a^2=-a[5]/e, b^2=-a[5]/h
                    c[1]=sqrt(fabs(-a[5]/h)); 
                } 
            }
        }
        else //  ,    x^2  y^2   (2xy+2x+2y+c=0);
        {
            b[1]=b[5]=b[4]=sqrt(2.)/2; //   tg a   1 ,  sin a=cos a=sqrt(2)/2
            //x1=b[1]x+b[2]y, y1=b[4]x+b[5]y
            b[2]=-sqrt(2.)/2;
            if(a[3]!=0 || a[4]!=0) // ,        x  y   
            {
                b[0]=(a[3]+a[4])/(sqrt(2.)*a[1]);//x2=x1+b[0], y2=y1+b[3]
                b[3]=-(a[4]-a[3])/(sqrt(2.)*a[1]);
                P=2*a[3]*a[4]-a[5]; //P - ,    , .. a[1]x2^2+a[1]y2^2=P
                if(P==0) P=1; // P=0,      a[1]
                c[0]=sqrt(fabs(P/a[1]));
                c[1]=sqrt(fabs(P/a[1]));
            }
            else // ,    x  y   (2xy+c=0)
            {
                b[0]=b[3]=0; // .. -  x  y  ,  -   
                if (a[5]!=0) // ,      
                {
                    c[0]=c[1]=sqrt(fabs(-a[5]/a[1])); //  a[1]*x^2-a[1]*y^2=-a[5], .. a^2=-a[5]/a[1]  b^2=a[5]/a[1]
                } 
                else // ,      (2xy=0)
                { 
                    c[0]=c[1]=sqrt(fabs(1/a[1]));//  a[1]*x^2-a[1]*y^2=0, .. a^2=1/a[1]  b^2=1/a[1]
                }
            }
        }
    }
    else { // ,    xy  (x^2+y^2+2x+2y+c=0), ..   
        if (fabs(a[0])>eps  && fabs(a[2])>eps) // ,       x^2  y^2   
        {
            if (fabs(a[3])>eps || fabs(a[4])>eps)// ,        x  y   
            {
                b[1]=b[5]=1; //..   xy  ,  x1=b[1]*x, y1=b[5]*y
                b[2]=b[4]=0;
                b[0]=a[3]/a[0]; //  x2=x1+b[0], y2=y1+b[3]
                b[3]=a[4]/a[2];
                P=a[3]*a[3]/a[0]+a[4]*a[4]/a[2]-a[5]; //,    
                if(P==0) P=1; // P=0,     a[0]  a[2]
                c[0]=sqrt(fabs(P/a[0])); //a^2=P/a[0]
                c[1]=sqrt(fabs(P/a[2])); //b^2=P/a[2]
            }
            else // ,    x  y  
            {
                b[1]=b[5]=1; //..   xy, x, y  ,  x2=x1=x  y2=y1=y
                b[0]=b[2]=b[3]=b[4]=0;
                if (a[5]!=0) //  ,       (x^2+y^2+c=0)
                {
                    c[0]=sqrt(fabs(-a[5]/a[0])); //a^2=a[5]/a[0]
                    c[1]=sqrt(fabs(-a[5]/a[2])); //b^2=a[5]/a[2]
                }
                else //  ,      (x^2+y^2=0)
                { 
                    c[0]=sqrt(fabs(1/a[0])); //a^2=1/a[0]
                    c[1]=sqrt(fabs(1/a[2])); //b^2=1/a[2]
                }
            }
        }
        else // ,        x^2  y^2  
        {
            b[1]=b[5]=1; //x1=x, y1=y, ..   xy  ,      
            b[2]=b[4]=0;
            if (fabs(a[0])<=eps && fabs(a[2])>eps) // ,    x^2  ,    y^2   
            {
                if (a[3]!=0) // ,    x   (y^2+2x+2y+c=0);
                {
                    b[0]=-(a[4]*a[4])/(2*a[2]*a[3])+a[5]/(2*a[3]); // x1=x+b[0]
                    b[3]=a[4]/a[2]; //y1=y+b[3]
                    c[0]=0; //..   x^2  
                    c[1]=1; 
                } 
                else // ,    x  , ..       (y^2+2y+c=0)
                {
                    b[0]=b[1]=0; //..   x  
                    b[3]=a[4]/a[0];//y1=y+b[3]
                    c[1]=1;
                }
            }
            if (fabs(a[2])<=eps && fabs(a[0])>eps) // ,    y^2  ,    x^2   
            {
                if (fabs(a[4])>eps) // ,    y    (x^2+2x+2y+c=0);
                {
                    b[0]=a[3]/a[0];//x1=x+b[0]
                    b[3]=-(a[3]*a[3])/(2*a[4]*a[0])+a[5]/(2*a[4]);//y1=y+b[3]
                    c[0]=1;
                    c[1]=0; //..   y^2  
                } 
                else // ,    y   (x^2+2x+c=0);
                    { 
                        b[0]=a[3]/a[2]; //x1=x+b[0]
                        b[3]=b[5]=0; //..   y  
                        c[0]=1;
                    } 
            }
            if(fabs(a[0])<=eps && fabs(a[2])<=eps)// ,    x^2  y^2   (2x+2y+c=0);
                    return 0; // 0, ..       
        }
    }
	//         :
    if(fabs(I2)<eps)
    {
        if (fabs(I3)>=eps)
            return 6;
        if(fabs(I3)<eps) 
        {
            if (fabs(K2)<eps)
                return 9;
            if(K2>0)
                return 8;
            if (K2<0)
                return 7;
        }
		return -1;
    }
    if(I2>eps)
        {
            if(fabs(I3)>=eps)
            {
                if(I3*I1<0)
                    return 1; 
                if(I3*I1>0)
                    return 2;
            }
            if(fabs(I3)<eps)
                return 3;
        }
    if(I2<0)
        {         
            if(fabs(I3)>=eps)
                return 4;
            if(fabs(I3)<eps)
                return 5;
        }
	return -1;
}


