// forders.h: 2016-05-18 Frobenius orders(c,a,b,p)
// (c) Khashin S.I.  khash2@gmail.com

//  ,   ,     
//      z=a+b*sqrt(c)     p, 
//    2    .

//============================================================================
// CLASS forders
//============================================================================
class forders {
private:
	static int a,b,c;						// z=a+b*sqrt(c)
	static unsigned nord;					// number of primes
	static unsigned *ord;					// array of order(a,p[i]), size = nord
	static u64      maxP_;					// last P
	//
//public:
	static int save(char *fname);				// save orders
	static int load(char *fname, u64 N=0);		// load orders (base)
	static char *forder_file_name(int a0, int b0, int c0);
	static int	calc(int a0, int b0, int c0, u64 maxN);// calculate orders(base)
public:
	static int  fill(int a0, int b0, int c0, u64 maxN=0);	// load/calculate seive and orders(base)
	static unsigned nOrd() {return nord; };		// number of calculated orders
	static u64      maxP() {return maxP_; };	// last P
	static int		A()	   {return a; };		// base
	static int		B()	   {return b; };		// base
	static int		C()	   {return c; };		// base
	static u64      fordI(unsigned i);			// FrobOrder(a,b,c, p(i))
	static u64      fordP(u64 p0);				// FrobOrder(a,b,c, p0)
	static unsigned fCordI(unsigned i);			// co-FrobOrder(a,b,c, p(i))
	static u64      fCordP(u64 p0);				// co-FrobOrder(a,b,c, p0)
};
