// 2017-07-09 histogram.h 
#include <stdlib.h>

#include "histogram.h"		// 

//-----------------------------------------------------------------------------
histogr::histogr() {
	min = 0;
	size = -1;
	sum = 0;
	v = NULL;
}
//-----------------------------------------------------------------------------
histogr::~histogr() {
	if (v != NULL) delete[]v;
}
//-----------------------------------------------------------------------------
void histogr::clear()		// 
{
	for (int i = 0; i < size; i++) v[i] = 0;
	sum = 0;
}
//-----------------------------------------------------------------------------
void histogr::add(int x)	//  
{
	sum++;
	const int size0 = 4;
	if (min <= x && x < min + size) {
		v[x - min]++;
		return;
	}
	if (v == NULL) {		//  
		size = size0;
		v = new int[size];
		min = x;
		v[0] = 1;
		for (int i = 1; i < size0; i++) v[i] = 0;
		return;
	}
	if (x >= min + size) {			//  
		int *w = v;
		int size1 = size;			//  
		int off = x - min;
		size = off + size / 2;		//  
		v = new int[size];
		for (int i = 0; i < size1; i++) v[i] = w[i];
		for (int i = size1; i < size; i++) v[i] = 0;
		v[x - min] = 1;
		delete[]w;					//  
		return;
	}
	if (x < min) {					//  
		int *w = v;
		int size1 = size;			//  
		int min1 = min;				//  

		min = x - size / 4;			//  
		size = min1 + size1 - min;	//  
		v = new int[size];
		for (int i = 0; i < size; i++) v[i] = 0;
		for (int i = 0; i < size1; i++)v[i - min + min1] = w[i];
		v[x - min] = 1;
		delete[]w;					//  
		return;
	}
}
//-----------------------------------------------------------------------------
int  histogr::get(int x)	//     x
{
	if (x < min) return 0;
	if (x >= min + size) return 0;
	return v[x - min];
}
//-----------------------------------------------------------------------------
int  histogr::Min() 
{
	int r = min;
	while (get(r) == 0) r++;
	return r; 
}
int  histogr::Max() 
{ 
	int r = min + size-1;
	while (get(r) == 0) r--;
	return r;
}
//-----------------------------------------------------------------------------
int  histogr::MaxCount(int &x)//  x   
{
	int cnt = -1;
	for( int i=0; i<size; i++ ) 
		if (v[i] > cnt) { cnt = v[i]; x = i; }
	x += min;
	return cnt;
}
//-----------------------------------------------------------------------------
int  histogr::quantil(double q)// :  k ,     <=k    q*sum
{
	long long S = (long long)(sum*q);
	int i;
	for (i = 0; i < size; i++) {
		S -= v[i];
		if (S < 0) break;
	}
	return min + i;
}
int  histogr::quantilR(double q)// :  k ,     >=k    q*sum
{
	long long S = (long long)(sum*q);
	int i;
	for (i = size-1; i >= 0; i--) {
		S -= v[i];
		if (S < 0) break;
	}
	return min + i - 1;
}


//