// igeom.cpp 2017-01-20    
// :
// Pnt, :     (x,y);
// Edg, :    (x0,y0)-(x1,y1)    (int *A, int *B)
// Tri, :  6  (x0,y0)-(x1,y1)-(x2,y2)    (int *A, int *B, int *C)
// Box, :   8  (x0,y0)-(x1,y1)-(x2,y2)-(x3,y3)   4  (int *A, int *B, int *C, int *D) 
#ifdef IGEOM
#error Secondary include
#endif
#define IGEOM

//-----------------------------------------------------------------------------
//  
int  sumSq(int a, int b);							// a*a + b*b
void setMinMax(int x, int &min, int &max);			//    ,  corrMinMax  vUtil
void neighb4(int x0, int y0, int K, int h, int &x2, int &y2);// K=0..3, (x2,y2):=   K   
void neighb8(int x0, int y0, int K, int h, int &x2, int &y2);// K=0..7, (x2,y2):=   K   

//-----------------------------------------------------------------------------
//  
// 
void   copyPnt(int *src, int *dst);				//  
void   copyEdg(int *src, int *dst);				//  
void   copyEdg(int *A, int *B, int *dst);
void   copyTri(int *src, int *dst);				//  
void   copyTri(int *A, int *B, int *C, int *dst);
void   copyBox(int *src, int *dst);				//  4-  
void   copyBox(int *A, int *B, int *C, int *D, int *dst);
void   swapE(int *edge);						//   

// 
double lenE(int *edge);							//  
double lenE(int x1, int y1, int x2, int y2);	//  
double lenE(int *P0, int *P1);					//  

//  - 
void   envelEdg(int &minX, int &minY, int &maxX, int &maxY, int *edg);		//  
void   envelSqu(int &minX, int &minY, int &maxX, int &maxY, int *di);		//     
void   envelEdg(int &minX, int &minY, int &maxX, int &maxY, int *A, int *B);//  
void   envelTri(int &minX, int &minY, int &maxX, int &maxY, int *tri);		//  
void   envelTri(int &minX, int &minY, int &maxX, int &maxY, int *A, int *B, int *C);//  
void   envelBox(int &minX, int &minY, int &maxX, int &maxY, int *box);				//  4-
void   envelBox(int &minX, int &minY, int &maxX, int &maxY, int *A, int *B, int *C, int *D);//  4-

int	   vectProd(int x1, int y1, int x2, int y2);// x1*y2 - x2*y1
// 
double kAngle(int *edge);						//   
double CanglE(int x0, int y0, int x1, int y1);	//    
double CanglE(int *A, int *B, int *C);			//   ABC
double CanglE(int *edge1, int *edge2);			//     ()
double CanglE(int *A, int *B, int *C, int *D);	//     [AB)  [CD)
void   CSanglE(int x0, int y0, int x1, int y1, double &co, double &si );// co:=cos(angle), si:=sin(angle) 
void   TransfE(int x0, int y0, int x1, int y1, int x2, int y2, int x3, int y3, double &a0, double &a1, double &co, double &si);//  ,  [01]->[23]

void   rotate(int *A, int *B, int *C, double angle);// C:=(B)  A   angle
void   rotate(int Ax, int Ay, int Bx, int By, int &Cx, int &Cy, double angle);// C:=(B)  A   angle
void   shiftE(int *A, int *B, int h, int *C, int *D);// [CD] :=  [AB]   h 
void   shiftE(int x0, int y0, int x1, int y1, int h, int &x2, int &y2, int& x3, int &y3);// [23] :=  [01]   h 

void   lineEq(int *edge, double &a, double &b, double &c);		 //   ax+by+c   
void   lineEq(int *P0, int *P1, double &a, double &b, double &c);//   ax+by+c   
double lineDist(int *edge, int *P);				//    P  ,  
double lineDist(int *A, int *B, int *P);		//    P  ,   [A,B]

// :
// 0 -  ,
// 1 -    ,
// 2 -      edge1
// 3 -      edge2
// 4 -      
int    intersection(int *edge1, int *edge2, double &x, double &y);	// (x,y):=  ,   
int    intersection(int *A, int *B, int *C, int *D, double &x, double &y);	// (x,y):=   (AB), (CD)

double distE0(int *edge, double x, double y);	//     
double distE(int *edge1, int *edge2);			//   . 0,  
double fndLine(int N, const int *v, double &a, double &b, double &c);//  N>1    <v[0],v[1]>,...,<v[2*N-2],v[2*N-1]>.   a*x+b*y+c=0   .
bool   SameP(int *p1, int *p2);					//    ?
bool   SameE(int *p1, int *p2);					//    ?
bool   almostSameP(int *p1, int *p2, int h = 1);//     ?
bool   almostSameE(int *p1, int *p2, int h = 1);//     ?
bool   isIn(int x0, int y0, int x1, int y1, int x, int y );//    (x,y)   <(x0,y0)-(x1,y1)>
bool   edgFar(int *A, int *B, int *C, int *D, int h);//  [AB]  [CD]  (h)   ?  
bool   edgFar(int *e1, int *e2, int h);			//  e1  e2  (h)   ?  

double joinE(int *A, int *B, int *C, int *D, int *join);	//  4-  ,  .   
double joinE(int *e1, int *e2, int *join);		// join:=(e1,e2),  .  e1,e2   

//-----------------------------------------------------------------------------
/*
class edgeIterator {	//    
private: 
	int x0, y0, x1, y1;
	int deltaX, deltaY, signX, signY, error;
public:
	~edgeIterator() {};				//   
	edgeIterator(int x0_, int y0_, int x1_, int y1_);
	edgeIterator(int *P0, int *P1);
	bool next();					// ,   
	int X() { return x0; };
	int Y() { return y0; };
};
// :
//	edgeIterator ei(20, 120, 120, 30);
//	do m.at<uchar>(ei.Y(), ei.X()) = 255;
//	while (!ei.next());
//-----------------------------------------------------------------------------
*/
//  reduceTo ,     edgeIterator,    !
#ifdef EDGE_ITERATOR
bool   reduceTo(int *edge, int x0, int y0, int x1, int y1);//  edge   <(x0,y0)-(x1,y1)>
#endif
void   expandEdg(int *A, int *B, int h);		//   [A,B]   B  h 
void   expandEdg(int x0, int y0, int &x1, int &y1, double q);//   [01]   1  q 
double edgProj( int *A, int *B, int *P);		// x: (P)   (AB)  x*A +(1-x)*B 
bool   edgAdd( int *e1, int *e2, int h1, int h2);//    e1   e2 (      h1, h2) 

int vectProd(int x1, int y1, int x2, int y2);	// x1*y2 - x2*y1

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
double areaT(int*A, int *B, int *C);	//   - ABC
int    areaT2(int*A, int *B, int *C);	// 2*  - ABC
bool   inAngle(int *A, int *B, int *C, int *P);				//  P   ABC?
bool   inTriangle(int x1, int y1, int x2, int y2, int x3, int y3);				//  (0,0)  ?
bool   inTriangle(int x1, int y1, int x2, int y2, int x3, int y3, int x, int y);//  (x,y)  ?
bool   inTriangle(int *P1, int *P2, int *P3, int *P);		//  (P,P+1)   (P1,P1+1),(P2,P2+1),(P3,P3+1)?
bool   SameT(int *p1, int *p2);//    ?

/////////////////////////////////////////////////////////////////////////////
// (a1,a2,a3) -    v   <v1,v2,v3>
void baricentr( int *v, int *v1, int *v2, int *v3,
				double &a1, double &a2,  double &a3 );

//-----------------------------------------------------------------------------
// 4-  (array of 8 integer)
//-----------------------------------------------------------------------------
bool   makeBox(int *A, int *B, int *C, int *D, int *box);	//  4-    4-. 
double CangleB(int *box, int k);		//    k-   
double lenB(int *box, int k);			//   k-   k+1
double areaB(int *box);					// 
double areaB(int *A, int *B, int *C, int *D); //  ABCD
bool   convex(int *A, int *B, int *C, int *D);// ?
bool   convex(int *box);				// ?
void   shiftB(int *box);				//     
void   boxLengthM(int *box, double &min, double &max);//      
void   boxCAngleM(int *box, double &min, double &max);//      
void   boxCenter(int *box, int &x, int &y);	// (x,y):=(box)
void   shrink(int *src, int *dst, int h);	// dst:= box(src)  h   
bool   inBox(int *box, int *P);				//  P   ?
bool   InBox(int *box, int x, int y);		//    (x,y)  box

//-----------------------------------------------------------------------------
// ,   
//-----------------------------------------------------------------------------

void   secondDiag(int *d1, int *d2);		//    d1,    d2
void   getDiag(int *s, int *d);				//     s,   d
void   getDiag(int xa, int ya, int xc, int yc, int &x0, int &y0, int &x1, int &y1);
bool   almostSameSq(int *d1, int *d2);		//    .    ?

//