// imatr_jpg.cpp jpeg  

#define _CRT_SECURE_NO_WARNINGS
// 
#include <stdio.h>
#include <string.h>
//  (..\vi05)
#include "vUtil.h"			//   
//#include "igeom.h"			//    
#include "iMatrix.h"		//  
#include "iMatrix3.h"		// 3-
#include "imatr_jpg.h"		//   jpeg

#include "..\\lib\\jpgs.h"  //   jpeg

#ifdef _WIN64
	#ifdef _DEBUG
		#pragma comment(lib, "../lib/jpgsD64.lib")
	#else
		#pragma comment(lib, "../lib/jpgsR64.lib")
	#endif
#else
	#if _MSC_VER ==1600	//  Visual C++ 2010
		#ifdef _DEBUG
			//#pragma comment(lib, "../lib/jpgsD8610.lib")
			#pragma comment(lib, "../lib/jpgsD86_15.lib")			// jpgsD8610.lib
		#else
			#pragma comment(lib, "../lib/jpgsR8610.lib")
		#endif
	#else				//  Visual C++ 2015
		#ifdef _DEBUG
			#pragma comment(lib, "../lib/jpgsD86_15.lib")
		#else
			#pragma comment(lib, "../lib/jpgsR86_15.lib")
		#endif
	#endif // #if _MSC_VER ==1600	//  Visual C++ 2010
#endif


int loadGrey(matr &a, const char *fname)
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.loadBMPGrey(fname);
	}
	BYTE *buf;
	int mx, my;
	int code = jpegs_load(buf, mx, my, fname);
	if (code)return code;
	a.setSize(mx, my);
	BYTE *b = buf;
	int yy, u, v;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			rgb_yuv(b[0], b[1], b[2], yy, u, v);
			a.put(x, y, yy);
			b += 3;
		}
	delete[]buf;
	return 0;
}
//-----------------------------------------------------------------------------
int loadRGB(matr &a, const char *fname)
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.loadBMP(fname);
	}
	BYTE *buf;
	int mx, my;
	int code = jpegs_load(buf, mx, my, fname);
	if (code)return code;
	a.setSize(mx, my);
	BYTE *b = buf;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			a.put(x, y, rgb_int(b[0], b[1], b[2]));
			b += 3;
		}
	delete[]buf;
	return 0;
}
//-----------------------------------------------------------------------------
int loadRGB(matr3 &a, const char *fname)
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.loadBMP(fname);
	}
	BYTE *buf;
	int mx, my;
	int code = jpegs_load(buf, mx, my, fname);
	if (code)return code;
	a.setSize(mx, my);
	BYTE *b = buf;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			a.r.put(x, y, b[0]);
			a.g.put(x, y, b[1]);
			a.b.put(x, y, b[2]);
			b += 3;
		}
	delete[]buf;
	return 0;
}
//-----------------------------------------------------------------------------
int saveGrey(matr &a, const char *fname, int q)		//    q, 0 <=q <=100
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.saveBMPGrey(fname);
	}
	//h_graph_set_options_jpg(q);
	int mx = a.Mx(), my = a.My();
	BYTE *buf = new BYTE[3*mx*my];
	BYTE *b = buf;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			int v = a.get(x, y);
			*b++ = v;
			*b++ = v;
			*b++ = v;
		}
	int code = jpegs_save(buf, mx, my, fname, q);
	delete[]buf;
	return code;
}
int saveRGB(matr &a, const char *fname, int q)
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.saveBMP(fname);
	}
	//h_graph_set_options_jpg(q);
	int mx = a.Mx(), my = a.My();
	BYTE *buf = new BYTE[3*mx*my];
	BYTE *b = buf;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			int v = a.get(x, y);
			*b++ = v & 255; v >>= 8;
			*b++ = v & 255; v >>= 8;
			*b++ = v & 255;
		}
	int code = jpegs_save(buf, mx, my, fname, q);
	delete[]buf;
	return code;
}
int saveRGB(matr3 &a, const char *fname, int q)
{
	if (strcmp(fileExt(fname), ".bmp") == 0) {
		return a.saveBMP(fname);
	}
	//h_graph_set_options_jpg(q);
	int mx = a.Mx(), my = a.My();
	BYTE *buf = new BYTE[3*mx*my];
	BYTE *bb = buf;
	for (int y = 0; y<my; y++)
		for (int x = 0; x < mx; x++) {
			*bb++ = a.r.get(x, y);
			*bb++ = a.g.get(x, y);
			*bb++ = a.b.get(x, y);
		}
	int code = jpegs_save(buf, mx, my, fname, q);
	delete[]buf;
	return code;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

