// substs.h substitusions
// (c) Khashin S.I.  khash2@gmail.com
//
typedef unsigned char      BYTE;

unsigned           factorial  (int n);	// n!
unsigned long long factorial64(int n);	// n!
int				   nKind(int n);		//     


class barray{			//  
protected:
	int n;				// number of elements
	BYTE *a;			// elements
public:
	// constructors/destructor
	barray(int n_=0);
	barray(barray &a){ vError("subs1::subs1(subs1 &a): copy constructor illegal"); }
	~barray();
	//
	void setN(int n_);					// setSize
	int  getN() { return n;}
	BYTE &operator[] (int i);			//     (  )
	void setA(BYTE *a1);				// copy from array
	void copyFrom(const barray &s);		// this := copyFrom(s)
	void set(BYTE v0, BYTE v1);
	void set(BYTE v0, BYTE v1, BYTE v2);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7, BYTE v8);
	void set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7, BYTE v8, BYTE v9);

	char *toString();
	bool isEqual(barray &s);			// this == s?
	bool operator==(barray &s);
	bool isSubs();						// all elements are different
	void sort();						// (22031) -> (32210)
	void swap(barray &s);				// this <-> s
	int  compare(const barray &s2);		//  
	bool operator< (const barray &s);	// 
	int  fromString(char *s);			//      0..9
};

int  compareBA(const void *s1, const void *s2);			//  

class subs: public barray{
public:
	// constructors/destructor
	subs(int n_ = 0);
	subs(const subs &a);

	char *toStringS();					//   

	void setId(int n_=0);				// this := id
	void mult(subs &s1, subs &s2);		// this := s1*s2
	void div(subs &s1, subs &s2);		// this := s1/s2
	void revers(subs &s);				// this := 1/s
	bool isCommut(subs &s);				// s*this=this*s?
	bool isH();							// without stable point
	unsigned index();					// index of substitution 
										//     n<=12 (13!>2^32)
	unsigned long long index64();		// index of substitution
										//     n<=20 (21!>2^64)
	void setByIndex(unsigned ind);		// this := substitution number ind,          n<=12
	void setByIndex64(unsigned long long ind);	// this := substitution number ind,  n<=20

	bool isE();							// this = id
	bool isSim(subs &s);				// this/s   ?
	int  fixCount();					//   

	void stype(barray &ba);				// ba:=     this,   s=(01)(2)(3456)(78)(9),  this=(422110000)
	//int  nKind();						//     
	int  itype();						//   
	int  itype(subs &s2);				//    this/s2
	void set_min(int k);				//    k

	void conj(subs &r, subs &t);		// this := r*t/r
	bool Find_conj(subs &r, subs &t);	// this := s such, that: t = s*r/s, 

	void commut(vector<subs> &comm);	// comm :=  ,   this
	void cycles(vector<subs> &cycl);	// cycl :=  -,   this
private:
	//   ,   
	int  cycle_len(int k);				//  ,    k-  (a[k])
};

bool subsSave(vector<subs> &v, const char *fname, char *msg="");//    
bool subsLoad(vector<subs> &v, const char *fname);//    

