// useful.h  ,    
// 2017-06-10
//
//////////////////////////////////////////////////////////////////////
#ifndef IMATRIX
#error iMatrix.h not included
#endif

#ifndef IMATRIX3
#error iMatrix3.h not included
#endif

#ifndef PVECTORS
#error pvectors.h not included
#endif

#ifndef VTRANSF
#error vTransf.h not included
#endif

#define USEFUL

// list:=     N*M,   (x0,y0)
void   setListSQ(pvector &list, int x0, int y0, int N, int M);	// list:=   N*M,   (x0,y0)

//-----------------------------------------------------------------------------
//  
void mShift1(matr  &src, matr &dst,  double vx, double vy);		// dst:= src   (vx,vy)
void mShift3(matr  &src, matr &dst,  double vx, double vy);		// dst:= src   (vx,vy) 
void mShift1(matr3 &src, matr3 &dst, double vx, double vy);		// dst:= src   (vx,vy)
void mShift3(matr3 &src, matr3 &dst, double vx, double vy);		// dst:= src   (vx,vy) 

//-----------------------------------------------------------------------------
//  
void   trApply1(matr  &dst, matr  &src, CvTransf &tr);			// dst:=tr(src) 
void   trApply3(matr  &dst, matr  &src, CvTransf &tr);			// dst:=tr(src) 
void   trApply1(matr3 &dst, matr3 &src, CvTransf &tr);			// dst:=tr(src) 
void   trApply3(matr3 &dst, matr3 &src, CvTransf &tr);			// dst:=tr(src) 

//  
double trApply1(matr  &f0, matr  &f1, CvTransf &tr, matr &er);	// er:= tr    
double trApply3(matr  &f0, matr  &f1, CvTransf &tr, matr &er);	// er:= tr    
double trApply1(matr3 &f0, matr3 &f1, CvTransf &tr, matr &er);	// er:= tr    
double trApply3(matr3 &f0, matr3 &f1, CvTransf &tr, matr &er);	// er:= tr    


//=============================================================================
//    
//=============================================================================
//void setMult(double coeff);		//  ,      S
//void setSqrt(bool sqrt=true);		//        S

// 2018-03-27   fSi  :      (Gvx0, Gvy0)   Gco
//void   setGSi(double Gvx0_, double Gvy0_, double Gco_);
// fS*:  S,   ()
// fE*:    , 
//  matr : err = sqrt(S/size)
//  matr3: err = sqrt(S/(3*size)

//  :
double fSi(matr  &a, matr  &b, int vx, int vy, pvector &list);	// S     
double fSi(matr3 &a, matr3 &b, int vx, int vy, pvector &list);	// S     ,
double fSi(matr  &a, matr  &b, int vx, int vy, int x, int y);	// S     
double fSi(matr3 &a, matr3 &b, int vx, int vy, int x, int y);	// S     

inline double fEi(matr  &a, matr  &b, int vx, int vy, pvector &list) { return sqrt(fSi(a, b, vx, vy, list) / list.size()); }
inline double fEi(matr3 &a, matr3 &b, int vx, int vy, pvector &list) { return sqrt(fSi(a, b, vx, vy, list) / (3*list.size()));}
inline double fEi(matr  &a, matr  &b, int vx, int vy, int x, int y)  { return sqrt(fSi(a, b, vx, vy, x,y)); }
inline double fEi(matr3 &a, matr3 &b, int vx, int vy, int x, int y)  { return sqrt(fSi(a, b, vx, vy, x, y) / 3); }

// DOUBLE  & AFFINE:
double fS1Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y);// S   
double fS3Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y);// S   
double fS1Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y);		// S   
double fS3Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y);		// S   
double fS1Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y);		// S   
double fS3Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y);		// S   

inline double fE1Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y) { return sqrt(fS1Pnt(a, b, dx, dy, x, y) / 3); }
inline double fE3Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y) { return sqrt(fS3Pnt(a, b, dx, dy, x, y) / 3); }
inline double fE1Pnt(matr  &a, matr  &b, CvTransf &tr,         int x, int y) { return sqrt(fS1Pnt(a, b, tr,     x, y) / 3); }
inline double fE3Pnt(matr  &a, matr  &b, CvTransf &tr,         int x, int y) { return sqrt(fS3Pnt(a, b, tr,     x, y) / 3); }
inline double fE1Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y) { return sqrt(fS1Pnt(a, b, tr, x, y) / 3); }
inline double fE3Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y) { return sqrt(fS3Pnt(a, b, tr, x, y) / 3); }

double fSd1(matr  &a, matr  &b, double vx, double vy, pvector &list);// S       
double fSd3(matr  &a, matr  &b, double vx, double vy, pvector &list);// S     
double fSd1(matr3 &a, matr3 &b, double vx, double vy, pvector &list);// S       
double fSd3(matr3 &a, matr3 &b, double vx, double vy, pvector &list);// S     

inline double fEd1(matr  &a, matr  &b, double vx, double vy, pvector &list) { return sqrt(fSd1(a, b, vx, vy, list) / (list.size())); }
inline double fEd3(matr  &a, matr  &b, double vx, double vy, pvector &list) { return sqrt(fSd3(a, b, vx, vy, list) / (list.size())); }
inline double fEd1(matr3 &a, matr3 &b, double vx, double vy, pvector &list) { return sqrt(fSd1(a, b, vx, vy, list) / (list.size()*3)); }
inline double fEd3(matr3 &a, matr3 &b, double vx, double vy, pvector &list) { return sqrt(fSd3(a, b, vx, vy, list) / (list.size()*3)); }

double fS1(matr  &a, matr  &b, CvTransf &tr, pvector &list);	// S   
double fS3(matr  &a, matr  &b, CvTransf &tr, pvector &list);	// S   
double fS1(matr3 &a, matr3 &b, CvTransf &tr, pvector &list);	// S   
double fS3(matr3 &a, matr3 &b, CvTransf &tr, pvector &list);	// S   

inline double fE1(matr  &a, matr  &b, CvTransf &tr, pvector &list) { return sqrt(fS1(a, b, tr, list) / (list.size())); }
inline double fE3(matr  &a, matr  &b, CvTransf &tr, pvector &list) { return sqrt(fS3(a, b, tr, list) / (list.size())); }
inline double fE1(matr3 &a, matr3 &b, CvTransf &tr, pvector &list) { return sqrt(fS1(a, b, tr, list) / (list.size()*3)); }
inline double fE3(matr3 &a, matr3 &b, CvTransf &tr, pvector &list) { return sqrt(fS3(a, b, tr, list) / (list.size()*3)); }

double fSV1(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list);	// S     
double fSV3(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list);	// S     
double fSV1(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list);	// S     
double fSV3(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list);	// S     

inline double fEV1(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list) { return sqrt(fSV1(a, b, vx, vy, list) / (list.size())); }
inline double fEV3(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list) { return sqrt(fSV3(a, b, vx, vy, list) / (list.size())); }
inline double fEV1(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list) { return sqrt(fSV1(a, b, vx, vy, list) / (list.size()*3)); }
inline double fEV3(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list) { return sqrt(fSV3(a, b, vx, vy, list) / (list.size()*3)); }

//=============================================================================
//  
//=============================================================================
#define flowK 16									//    
#define flowCo 0.0625								// 1/flowK

double flowMax(matr &vx, matr &vy);									//   
void   saveFlowBlock(matr &vx, matr &vy, int x0, int y0, int dx, int dy, char *fname);

void   showVxVy(matr &vx, matr &vy, char *fname, int co = -4);		//    (vx,vy)  bmp- fname
void   vecApply(matr3 &f1, matr &vx, matr &vy, matr3 &g0);			//    (vx,vy)  g0

double flowQ(matr3 &f0, matr3 &f1, matr &vx, matr &vy, matr &res);	// res:=    
double flowQ(matr3 &f0, matr3 &f1, matr &vx, matr &vy);				//  

double flowVar(matr &vx, matr &vy, matr &res);						// res:=    
double flowVar(matr &vx, matr &vy);									//  

double flowAff(matr &vx, matr &vy, pvector &list, CvTransf &tr);	// tr :=   

void   setFlow(segm &sgm, int iS, CvTransf &tr, matr &vx, matr &vy);//    iS    . tr
void   setFlow(pvector list, CvTransf &tr, matr &vx, matr &vy);		//       . tr

//=============================================================================
// - -
double LK0_searchI(matr3 &a, matr3 &b, pvector &list, int h, int Nh, int &vx, int &vy, char *prot = NULL);	//       h,  Nh , 
double LK0_searchD(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot = NULL);//     h,  Nh , double
void LK0_search(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot = NULL);	//     h,  Nh 

void IsProtU(char *prot);											// /      
double LK5_opt(matr3 &f0, matr3 &f1, pvector &list, CvTransf &tr);	//    tr   list

double LK0_optI(matr3 &a, matr3 &b, pvector &list, int &vx, int &vy, int maxV, char *prot = NULL);//     
double LK0_optJ(matr3 &a, matr3 &b, pvector &list, int &vx, int &vy, int vx0, int vy0, int maxV, char *prot = NULL);//    + (x0,y0)  

//-----------------------------------------------------------------------------
bool LK0_uStep(matr3 &as, matr3 &bs, matr3 &bx, matr3 &by, int x, int y, double &x1, double &y1, double &mse); //     
int  LK0_uSteps(matr3 &as, matr3 &bs, matr3 &bx, matr3 &by, int x, int y, double &x1, double &y1, double &mse, int rep = 3); //    .   

// - -
void LK0_usual(matr3 &a, matr3 &b, matr &vx, matr &vy, int rep=3);	// (vx,vy) :=    (a,b)   

void normaSh(int x, double &dx, int max);	//  
int previous(matr &a, int x, int y);		//     
int midNeib (matr &a, int x, int y, int h=1);//        h

// solve:
// a0 + a1*x + a2*y = 0
// a3 + a4*x + a5*y = 0
bool solve22(double *a, double &x, double &y);

//=============================================================================
class dMin2 {//   .    x[i]    
public:
	int i0, i1;
	double v0, v1;
	// constructors/destructor
	dMin2() {
		i0 = i1 = -1;
		v0 = v1 = dbl_MAX;
	}
	void init() {
		i0 = i1 = -1;
		v0 = v1 = dbl_MAX;
	}
	void add(int i, double v) {
		if (v >= v1) return;
		if (v < v0) {
			i1 = i0; v1 = v0;
			i0 = i; v0 = v;
			return;
		}
		// now v0 <= v < v1
		i1 = i;
		v1 = v;
	};
};//class dMin2 {//   .    x[i]    
//=============================================================================

//
