// vectU.h   
// (c) Khashin S.I.  khash2@gmail.com
//
//////////////////////////////////////////////////////////////////////
#ifdef VECTU
#error Secondary include
#endif
#define VECTU

//   -------------------
void   Vset(vector<double>&v, double x);		// v[i]=x
void   VsetP(vector<double>&v, double*x);		// v[i]=x[i]
void   Vset(vector<double>&v, double x0, double x1);// v[i]=random(x0,x1)
//  ---------------------------
void   Vadd(vector<double>&v, vector<double> &dv, double k);// v[i]+=dv[i]*k
void   VaddK(vector<double>&v, double k);		// v[i]+=k
void   Vadd(vector<double>&v, vector<double> &v0, vector<double> &dv, double k);// v=v0+k*dv
//  --------------------------
double Vnorma(vector<double>&v, double lam);	//     lam.    
void   Vmult(vector<double>&v, double x);		// v *= x
//  ---------------------------
double Vlen(vector<double>&v);					//  
double Vlen2(vector<double>&v);					//  ^2

double Vmax(vector<double>&v);					// 
double Vmin(vector<double>&v);					// 
double VmaxM(vector<double>&v);					//  
double VminM(vector<double>&v);					//  

int Vargmax(vector<double>&v);					//  
int Vargmax(vector<double>&v, double &w);		//  
int Vargmin(vector<double>&v);					//  
int VargmaxM(vector<double>&v);					//   
int VargminM(vector<double>&v);					//   

double Vsum(vector<double>&v);					//  
double VsumM(vector<double>&v);					//   

double Vdist(vector<double>&v, vector<double>&w);//   
double Vprod(vector<double>&v, vector<double>&w);//  
double Vcos(vector<double>&v, vector<double>&w); //    

bool   VinBox(vector<double>&min, vector<double>&v, vector<double>&max);// min[i]<=v[i]<=max[i]

//  ---------------------------
void   VProj(vector<double>&res, vector<double>&v, vector<double>&w);// res:=   v  w (res    v)
void   VProjO(vector<double>&res, vector<double>&v, vector<double>&w);// res:= v - proj(v,w) (res    v)

// v :=     <=d    x.   v=binomial(n+d,d)
void plukker(vector<double>&x, int d, vector<double> &v);

//----------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------
string SLtrim(string&s);								//   
string SRtrim(string&s);								//   
string Strim(string&s);									//     
void   SSplit(string &s, string delim, string &left, string &right);//     delim     
														
//char *HHgetItem(char *buf, string &s);				//   HparseS
void   HparseC(char *buf, vector<string> &items);		//   buf  
void   HparseS(string bf, vector<string> &items);		//   buf  
string VtoString(vector<double>&v, const char *format = "%10.5f,");	//   - 

int Sindex(vector<string>&lines, string s);				//     


//----------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------
void   VsaveA(FILE* f, vector<double>& v, const char* msg, const char* format = "%10.5f,");			//      f
void   VsaveS(const char * fname, vector<double>& v, const char* msg, const char* format = "%10.5f,");
string HreadString(FILE *f);					//   s    . False,    
void   HreadFile(char *fname, vector<string> &lines);	//     


//----------------------------------------------------------------------------

